import java.io.IOException;
import java.nio.ByteBuffer;
import java.nio.channels.SelectionKey;
import java.util.logging.Logger;

import com.sun.grizzly.CallbackHandler;
import com.sun.grizzly.TCPConnectorHandler;
import com.sun.grizzly.Context;
import com.sun.grizzly.IOEvent;


public class ServerProxyHandler extends Peers<TCPConnectorHandler> implements CallbackHandler<Context> {

    private static final Logger logger = Logger.getLogger(ServerProxyHandler.class.getName());

    private CircularByteBuffer circularBuffer = new CircularByteBuffer(65536, true); 
    
    private ByteBuffer buf = ByteBuffer.allocateDirect(16384);
    
    public void onConnect(IOEvent<Context> ioEvent) {
        logger.info("Proxy connected to server.");
        TCPConnectorHandler self = getSelf();
        Context context = ioEvent.attachment();
        SelectionKey key = context.getSelectionKey();
        self.finishConnect(key);
        // not connected, so mark interest with OP_CONNECT again
        if (!self.isConnected()) {
            key.interestOps(SelectionKey.OP_CONNECT);
        }
    }

    public void onRead(IOEvent<Context> ioEvent) {
        // we read from server-proxy and want to write to client-proxy
        try {
        buf.clear();
        getSelf().read(buf, false);
        circularBuffer.put(buf);
        getPeer().write(buf, false);
        }
        catch (IOException e) {
            
        }
    }

    public void onWrite(IOEvent<Context> ioEvent) {

    }
}
